Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1194927 - Review Request: nodejs-onetime - Only call a function once
Summary: Review Request: nodejs-onetime - Only call a function once
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Gerard Ryan
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: nodejs-reviews 1194931
TreeView+ depends on / blocked
 
Reported: 2015-02-20 23:23 UTC by Piotr Popieluch
Modified: 2015-03-14 09:22 UTC (History)
2 users (show)

Fixed In Version: nodejs-onetime-1.0.0-1.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-03-13 17:04:01 UTC
gerard: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Piotr Popieluch 2015-02-20 23:23:27 UTC
Spec URL: https://piotrp.fedorapeople.org/nodejs-onetime.spec
SRPM URL: https://piotrp.fedorapeople.org/nodejs-onetime-1.0.0-1.fc21.src.rpm
Description: Only call a function once
Fedora Account System Username: piotrp

Comment 1 Gerard Ryan 2015-03-01 21:26:12 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Source0 URL doesn't follow specific guideline regarding Github source URLs.
  Please see the following page for more information on making Github source URLs:
  https://fedoraproject.org/wiki/Packaging:SourceURL?rd=Packaging/SourceURL#Github
  Specifically, full commit hash is to be used instead of just %{version}.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 2 files have unknown license. Detailed output of
     licensecheck in /home/grdryn/rawhide/1194927-nodejs-
     onetime/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-onetime-1.0.0-1.fc23.noarch.rpm
          nodejs-onetime-1.0.0-1.fc23.src.rpm
nodejs-onetime.noarch: W: only-non-binary-in-usr-lib
2 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
nodejs-onetime (rpmlib, GLIBC filtered):
    nodejs(engine)



Provides
--------
nodejs-onetime:
    nodejs-onetime
    npm(onetime)



Source checksums
----------------
https://github.com/sindresorhus/onetime/archive/v1.0.0/onetime-1.0.0.tar.gz :
  CHECKSUM(SHA256) this package     : caf1904ca2e490103760d73c3896b184acdbd081b41f35eceef43f0347c7e5fd
  CHECKSUM(SHA256) upstream package : caf1904ca2e490103760d73c3896b184acdbd081b41f35eceef43f0347c7e5fd


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1194927
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 2 Gerard Ryan 2015-03-01 21:29:04 UTC
Hi Piotr,

I'll approve once the issue regarding Github source URL is fixed. I've probably missed that in the other reviews for you. If so, please consider updating them also! :)

Additionally, I think you can use %{srcname} in the URL line, the same way as you're using it in the Source0 line.

Thanks,
Gerard.

Comment 3 Piotr Popieluch 2015-03-04 20:00:35 UTC
Hi Gerard,

Thank you for pointing me to the Github source URL guidelines, it never occurred  to me that those might exist.. I probably have a dozen of packages using this incorrectly. I will check all my packages next weekend.

I've updated the spec and srpm without a version bump.

Thank you for reviewing!

Comment 4 Gerard Ryan 2015-03-04 20:10:52 UTC
(In reply to Piotr Popieluch from comment #3)
> Hi Gerard,
> 
> Thank you for pointing me to the Github source URL guidelines, it never
> occurred  to me that those might exist.. I probably have a dozen of packages
> using this incorrectly. I will check all my packages next weekend.
> 

Yes, it's hard to remember all of the rules all the time...it's a good thing we force ourselves to get our packages reviewed! :) I guess this particular one is because the tags aren't necessarily immutable, but the commit hashes are.

> I've updated the spec and srpm without a version bump.
> 
> Thank you for reviewing!

Thank you for packaging! It looks good to me now, so I'll approve it.

For any innocent bystanders, here's the diff of the spec file between the two versions:

--- srpm/nodejs-onetime.spec	2015-03-01 17:56:35.285000000 +0000
+++ nodejs-onetime.spec	2015-03-04 19:55:43.000000000 +0000
@@ -3,14 +3,15 @@
 
 %global enable_tests 1
 %global srcname onetime
+%global commit a4aa1ce5291cc5f32ecb8f4b0a918b12cb47ea5e
 
 Name:           nodejs-%{srcname}
 Version:        1.0.0
 Release:        1%{?dist}
 Summary:        Only call a function once
 License:        MIT
-URL:            https://github.com/sindresorhus/onetime
-Source0:        https://github.com/sindresorhus/%{srcname}/archive/v%{version}/%{srcname}-%{version}.tar.gz
+URL:            https://github.com/sindresorhus/%{srcname}
+Source0:        https://github.com/sindresorhus/%{srcname}/archive/%{commit}/%{srcname}-%{commit}.tar.gz
 
 BuildArch:      noarch
 ExclusiveArch:  %{nodejs_arches} noarch
@@ -28,7 +29,7 @@
 
 
 %prep
-%setup -q -n %{srcname}-%{version}
+%setup -q -n %{srcname}-%{commit}
 rm -rf node_modules/

Comment 5 Piotr Popieluch 2015-03-04 20:17:58 UTC
Thank you for review!

New Package SCM Request
=======================
Package Name: nodejs-onetime
Short Description: Only call a function once
Upstream URL: https://github.com/sindresorhus/onetime
Owners: piotrp
Branches: f20 f21 f22 el6 epel7

Comment 6 Gwyn Ciesla 2015-03-04 22:08:59 UTC
Git done (by process-git-requests).

Comment 7 Fedora Update System 2015-03-08 17:06:56 UTC
nodejs-onetime-1.0.0-1.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/FEDORA-2015-3272/nodejs-onetime-1.0.0-1.fc22

Comment 8 Fedora Update System 2015-03-08 17:09:04 UTC
nodejs-onetime-1.0.0-1.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/FEDORA-2015-3320/nodejs-onetime-1.0.0-1.fc21

Comment 9 Fedora Update System 2015-03-08 17:10:24 UTC
nodejs-onetime-1.0.0-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/FEDORA-2015-3313/nodejs-onetime-1.0.0-1.fc20

Comment 10 Fedora Update System 2015-03-13 17:04:01 UTC
nodejs-onetime-1.0.0-1.fc22 has been pushed to the Fedora 22 stable repository.

Comment 11 Fedora Update System 2015-03-14 09:12:23 UTC
nodejs-onetime-1.0.0-1.fc20 has been pushed to the Fedora 20 stable repository.

Comment 12 Fedora Update System 2015-03-14 09:22:35 UTC
nodejs-onetime-1.0.0-1.fc21 has been pushed to the Fedora 21 stable repository.


Note You need to log in before you can comment on or make changes to this bug.